
--
--  Gossipmonger
--    by Tuhljin
--
--  QuestHanger.lua
--

local frame = CreateFrame("Button", "Gossipmonger_QuestHanger", QuestFrame)
frame:SetWidth(24); frame:SetHeight(24);
frame:SetPoint("TOPRIGHT", QuestFrameCloseButton, "BOTTOMRIGHT", -15, 0)
frame:SetFrameLevel(QuestFrame:GetFrameLevel() + 1)
frame.tex = frame:CreateTexture(nil, "ARTWORK")
frame.tex:SetTexture("Interface\\AddOns\\Gossipmonger\\OpenBubbleBtn")
frame.tex:SetWidth(24); frame.tex:SetHeight(24);
frame.tex:SetPoint("LEFT")
frame.texhighlight = frame:CreateTexture(nil, "HIGHLIGHT")
frame.texhighlight:SetTexture("Interface\\AddOns\\Gossipmonger\\OpenBubbleBtnHighlight")
frame.texhighlight:SetWidth(24); frame.texhighlight:SetHeight(24);
frame.texhighlight:SetPoint("CENTER", frame.tex, "CENTER")

local function OnClick(self, button)
  Gossipmonger.ShowMirror()
end

local function CheckShow()
  if (not QuestFrame:IsShown()) then  return;  end
  if (not Gossipmonger_MirrorFrame:IsShown() and Gossipmonger_MirrorFrame.NPCName == UnitName("npc") and
      (Gossipmonger_MirrorFrame.numOptions or 0) > 1) then
    frame:Show()
  else
    frame:Hide()
  end
end

local function OnEvent(self, event)
  CheckShow()
  if (not Gossipmonger_MirrorFrame.selected) then
  -- Find the option button that corresponds to the selected quest and mark it as selected:
    local title = GetTitleText()
    local btn
    for i=1,Gossipmonger_MirrorFrame.numOptions or 0 do
      btn = _G["Gossipmonger_OptionDisplay"..i]
      if (not btn) then 
        break;
      elseif (btn.title == title and btn.type ~= "Gossip") then
        Gossipmonger.PrepGossipOptionDisplay(i, btn.baseButton, true)
        Gossipmonger_MirrorFrame.selected = i
        break;
      end
    end
  end
end

frame:SetScript("OnClick", OnClick)
frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent("QUEST_DETAIL")
frame:RegisterEvent("QUEST_PROGRESS")
frame:RegisterEvent("QUEST_COMPLETE")

Gossipmonger_MirrorFrame:HookScript("OnShow", CheckShow)
Gossipmonger_MirrorFrame:HookScript("OnHide", CheckShow)
